#ifndef GRAPH_H
#define GRAPH_H

extern char *screen;
extern char vscreen[], vscreen2[];
extern char screens[4][38*1024];

void flushscreens();
void outc(char color, char red, char green, char blue);
void setpal(char *pal);
void waitretrace();

typedef struct
{ short height, width;
  unsigned char *image, *palette;
} bitmap;

void putbitmap(char *dest, int x, int y, bitmap *b);
bitmap loadpcxlump(char *s);

void putbitmaptrans(char *dest, int x, int y, bitmap *b);
bitmap loadpcxlump(char *s);

void setmode(int mode);
#pragma AUX setmode = \
"int 0x10"            \
parm [ax];

void setmask(char mask);
#pragma AUX setmask =\
"mov dx,0x3c4"       \
"mov al,2"           \
"out dx,al"          \
"inc dx"             \
"mov al,ah"          \
"out dx,al"          \
modify [dx ax]       \
parm [ah];

#endif
