#include <conio.h>
#include <stdio.h>
#include <string.h>

#include "camoufst.h"
#include "dip.h"
#include "feedback.h"
#include "graph.h"
#include "hirmu.h"
#include "music.h"
#include "nethack.h"
#include "pud.h"
#include "resout.h"
#include "roto.h"
#include "text.h"
#include "ugly.h"
#include "vball.h"

void dohirmu()
{ frame=0;
  while(!kbhit() && !order)
  { advhirmu(frame);
    frame=0;
    memset(vscreen, 255, 64000);
    drawhirmu(vscreen);
    waitretrace();
    memcpy(screen, vscreen, 64000);
    updateinfo();
  }
}

void setcursortype(short type);
#pragma aux setcursortype = \
"mov ax,0x100"              \
"int 0x10"                  \
modify [ax]                 \
parm [cx];

void dotextcredits()
{ setmode(0x3);
  setcursortype(0x2000);
//  _settextcursor(0x2000);
  while(!kbhit() && order<3)
  { advtextcredits(0);
    drawtextcredits();
  }
  setmode(0x13);
}

void dofeedback()
{ int res=33;

  frame=0;
  memset(vscreen, 0, 64000);
  while(!kbhit() && order<5)
  { advfeedback(frame);
    updateinfo();
    if(row<60)
    { res-=frame;
      if(res<0) res=0;
    }
    else
    { res+=frame;
      if(res>33) res=33;
    }
    frame=0;
    drawfeedback(vscreen);
    if(res)
    { resout(vscreen2, vscreen, res);
      waitretrace();
      memcpy(screen, vscreen2, 64000);
    }
    else
    { waitretrace();
      memcpy(screen, vscreen, 64000);
    }
    updateinfo();
  }
}

void dougly()
{ bitmap sync;
  if(dip[UGLY])
  { sync=loadpcxlump("image.sync");
    setpal(sync.palette);
    memcpy(screen, sync.image, 64000);
    while(!kbhit() && order<7) updateinfo();
    return;
  }
  while(!kbhit() && order<7)
  { advugly();
    waitretrace();
    updateinfo();
  }
  setmode(0x13);
}

int dorotzoom()
{ int fm=0;
  frame=0;
  while(!kbhit() && order<9)
  { advrotzoom(frame);
    frame=0;
    drawrotzoom(screen);
    updateinfo();
    fm++;
  }

  return fm;
}

void docdthing()
{ frame=0;
  memset(vscreen, 0, 64000);
  while(!kbhit() && order<10)
  { advcdthing();
    frame=0;
    waitretrace();
    memcpy(screen, vscreen, 65536);
    updateinfo();
  }
}

void dovball()
{ frame=0;
  memset(vscreen, 0, 64000);
  while(!kbhit() && order<11) 
  { advcdthing();
    advvball(frame);
    frame=0;
    drawvball();
    waitretrace();
    memcpy(screen, vscreen, 65536);
    updateinfo();
  }
}

void donethack()
{ int n=0;
  frame=0;
  setmode(0x12);
  outp(0x3d4,9);
  outp(0x3d5,0);
  while(!kbhit() && !n)
  { n=advnethack(frame);
    frame=0;
    waitretrace();
    drawnethack();
  }
}

void printdips()
{ int i;
  for(i=0; i<16; i++) printf("%d", dip[i]);
}

main()
{ initpudfile("nf2.pud");
  inithirmu();
  initfeedback();
  initrotzoom();
  initcdthing();
  initvball();
  initugly();
  setmode(0x13);
  dipsie();
  initresout();
  initnethack();
  startmusic(1, "nf2.it");
  setmode(0x13);
  dohirmu();
  if(dip[CREDITS] && !kbhit()) dotextcredits();
  if(!kbhit()) dofeedback();
  if(!kbhit()) dougly();
  if(!kbhit()) dorotzoom();
  if(!kbhit()) docdthing();
  if(!kbhit()) dovball();
  if(!kbhit()) donethack();
  stopmusic();
  while(kbhit()) getch();
  setmode(0x3);
  printf("A Green Grapes Production\n");
  printdips();
}
