#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include "dip.h"
#include "graph.h"
#include "pud.h"

char *screen=(char *)0xa0000;
char vscreen[64000], vscreen2[64000];
char screens[4][38*1024];

void flushscreens()
{ int i, n=1;

  for(i=0; i<4; i++, n*=2)
  { setmask(n);
    memcpy((char *)0xa0000+80*40+(80*dip[NETHACK]*i),
           screens[i]+80*40, 38*1024-80*80);
  }
}

void outc(char color, char red, char green, char blue)
{ outp(968, color);
  outp(969, red);
  outp(969, green);
  outp(969, blue);
}

void setpal(char *pal)
{ int i;

  outp(968, 0);
  for(i=0; i<768; i++) outp(969, pal[i]);
}

void waitretrace()
{ while(inp(0x3da)&8);
  while(!(inp(0x3da)&8));
}

bitmap decodepcx(char *p)
{ unsigned long n=0, i, q;
  unsigned char c;
  bitmap image;

  image.width=p[8]+p[9]*256+1;
  image.height=p[10]+p[11]*256+1;
  image.image=(char *)malloc(image.width*image.height);

  q=128;
  for(n=0; n<image.width*image.height;)
  { c=p[q++];
    if(c<192) (image.image)[n++]=c;
    else
    { i=c-192;
      c=p[q++];
      for(; i>0; i--)
        (image.image)[n++]=c;
    }
  }

  q++;

  image.palette=(char *)malloc(768);
  for(i=0; i<768; i++)
    (image.palette)[i]=p[q++]>>2;

  return image;
}

void putbitmap(char *dest, int x, int y, bitmap *b)
{ int i, j, n=0, xs=0, xe;
  char *p;

  if(x<0) xs=-x, x=0;
  xe=b->width;
  if(x+xe>320) xe=320-x;
  for(i=0; i<b->height; i++)
    if(i>0 && i<199)
    { p=dest+(i+y)*320+x;
      n+=xs;
      for(j=xs; j<xe; j++, n++)
        *p++=b->image[n];
      n+=b->width-xe;
    }
}

void putbitmaptrans(char *dest, int x, int y, bitmap *b)
{ int i, j, n=0, xs=0, xe;
  char *p;

  if(x<0) xs=-x, x=0;
  xe=b->width;
  if(x+xe>320) xe=320-x;
  for(i=0; i<b->height; i++)
    if(i>0 && i<199)
    { p=dest+(i+y)*320+x;
      n+=xs;
      for(j=xs; j<xe; j++, n++)
        if(b->image[n]) *p++=b->image[n];
        else p++;
      n+=b->width-xe;
    }
}

bitmap loadpcxlump(char *s)
{ char *t;
  bitmap b;

  t=loadlump(s);
  b=decodepcx(t);
  free(t);
  return b;
}
