#include "midasdll.h"

int order, pattern, row, syncinfo;
volatile int frame;

MIDASmodule module;                     /* Der Module */
MIDASmodulePlayHandle playhandle;       /* Das Playing Handle */

void MIDAS_CALL timerhandler(int sync, int order, int row)
{ frame++;
}

void updateinfo()
{ static MIDASplayStatus status;

  MIDASgetPlayStatus(playhandle, &status);

  order=status.position;
  pattern=status.pattern;
  row=status.row;
  syncinfo=status.syncInfo;
}

void startmusic(int n, char *s)
{ MIDASstartup();
  if(n) MIDASconfig();
  MIDASinit();
  module=MIDASloadModule(s);
  MIDASsetTimerCallbacks(70000, 1, &timerhandler, 0, 0);
  playhandle=MIDASplayModule(module, 1);
}

void stopmusic()
{ MIDASstopModule(playhandle);
  MIDASfreeModule(module);
  MIDASclose();
}
